package dev.inmo.postssystem.features.auth.client.ui

import kotlinx.serialization.Serializable

@Serializable
sealed interface AuthUIError {
//    @Serializable
    object ServerUnavailable : AuthUIError
//    @Serializable
    object AuthIncorrect : AuthUIError
}

@Serializable
sealed interface AuthUIState {
    @Serializable
    data class Init(val showError: AuthUIError? = null) : AuthUIState
//    @Serializable
    object Loading : AuthUIState
//    @Serializable
    object Authorized : AuthUIState

    companion object {
        val DefaultInit = Init()
    }
}
