package dev.inmo.postssystem.features.users.server

import dev.inmo.postssystem.features.users.common.*
import dev.inmo.micro_utils.ktor.server.configurators.ApplicationRoutingConfigurator
import dev.inmo.micro_utils.repos.ktor.server.crud.configureReadCRUDRepoRoutes
import io.ktor.server.auth.authenticate
import io.ktor.server.routing.Route
import io.ktor.server.routing.route

class UsersStorageServerRoutesConfigurator(
    private val usersStorage: ReadUsersStorage
) : ApplicationRoutingConfigurator.Element {
    override fun Route.invoke() {
        authenticate {
            route(usersServerPathPart) {
                configureReadCRUDRepoRoutes(
                    usersStorage
                ) { UserId(it.toLong()) }
            }
        }
    }
}
