package dev.inmo.postssystem.server

import dev.inmo.micro_utils.ktor.server.configurators.StatusPagesConfigurator
import io.ktor.server.application.call
import io.ktor.http.HttpStatusCode
import io.ktor.server.plugins.statuspages.StatusPagesConfig
import io.ktor.server.response.respondRedirect

data class NotFoundStatusPageRedirectToIndex(
    val redirectTo: String
) : StatusPagesConfigurator.Element {
    override fun StatusPagesConfig.invoke() {
        status(HttpStatusCode.NotFound) { _ ->
            call.respondRedirect(redirectTo)
        }
    }
}
